package org.processmining.plugins.simplelogoperations;

import java.awt.Color;

import javax.swing.*;

import com.fluxicon.slickerbox.factory.*;

public class AddEventsPanel extends JPanel {
	private static final long serialVersionUID = 0;

	private JPanel panel;

	private JLabel title;
	private JLabel lStart, lStop;
	private JCheckBox cStart, cStop;
	private JTextField tStart, tStop;

	public AddEventsPanel() {
		this.init();
	}

	private void init() {
		SlickerFactory factory = SlickerFactory.instance();
		SlickerDecorator decorator = SlickerDecorator.instance();
		panel = factory.createRoundedPanel(15, Color.gray);

		this.title = factory.createLabel("Add artificial events");
		this.title.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 18));
		this.title.setForeground(new Color(40, 40, 40));

		this.lStart = factory.createLabel("Add artificial start task");
		this.lStart.setForeground(new Color(40, 40, 40));
		this.lStop = factory.createLabel("Add artificial end task");
		this.lStop.setForeground(new Color(40, 40, 40));

		this.cStart = new JCheckBox();
		this.cStart.setBackground(Color.GRAY);
		this.cStart.setSelected(true);
		decorator.decorate(this.cStart);
		this.cStop = new JCheckBox();
		this.cStop.setBackground(Color.GRAY);
		this.cStop.setSelected(true);
		decorator.decorate(this.cStop);

		this.tStart = new JTextField(50);
		this.tStart.setText("START");
		this.tStart.setForeground(new Color(40, 40, 40));
		this.tStop = new JTextField(50);
		this.tStop.setText("END");
		this.tStop.setForeground(new Color(40, 40, 40));

		this.panel.setLayout(null);
		this.panel.add(this.title);
		this.panel.add(this.lStart);
		this.panel.add(this.cStart);
		this.panel.add(this.tStart);
		this.panel.add(this.lStop);
		this.panel.add(this.cStop);
		this.panel.add(this.tStop);

		this.panel.setBounds(0, 0, 700, 200);
		this.title.setBounds(10, 10, 200, 30);
		this.lStart.setBounds(20, 50, 150, 20);
		this.cStart.setBounds(170, 50, 20, 20);
		this.tStart.setBounds(200, 50, 200, 20);
		this.lStop.setBounds(20, 80, 150, 20);
		this.cStop.setBounds(170, 80, 20, 20);
		this.tStop.setBounds(200, 80, 200, 20);

		this.setLayout(null);
		this.add(panel);
		this.validate();
		this.repaint();
	}

	public boolean isAddStartTask() {
		return cStart.isSelected();
	}

	public String getStartTaskName() {
		return tStart.getText();
	}

	public boolean isAddStopTask() {
		return cStop.isSelected();
	}

	public String getStopTaskName() {
		return tStop.getText();
	}
}
