package org.processmining.plugins.simplelogoperations;

import java.awt.Color;
import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import com.fluxicon.slickerbox.factory.SlickerFactory;

public class MergePanel extends JPanel {

	private static final long serialVersionUID = -5464622787822138820L;
	public static int WIDTH = 0, HEIGHT = 0;
	private boolean first, last;
	private JTextField tFrom1, tFrom2, tInto;
	private JButton bRemove, bUp, bDown;

	public MergePanel(boolean first, boolean last) {
		super();
		this.first = first;
		this.last = last;

		SlickerFactory factory = SlickerFactory.instance();
//		SlickerDecorator decorator = SlickerDecorator.instance();

		setBackground(Color.gray);

		JLabel merge = factory.createLabel("Merge");
		merge.setForeground(new Color(40, 40, 40));
		JLabel plus = factory.createLabel("+");
		plus.setForeground(new Color(40, 40, 40));
		JLabel returns = factory.createLabel("=");
		returns.setForeground(new Color(40, 40, 40));

		tFrom1 = new JTextField("from");
		tFrom1.setForeground(new Color(40, 40, 40));
		tFrom2 = new JTextField("from");
		tFrom2.setForeground(new Color(40, 40, 40));
		tInto = new JTextField("into");
		tInto.setForeground(new Color(40, 40, 40));

		bRemove = factory.createButton("remove");
		bRemove.setForeground(new Color(40, 40, 40));
		bUp = factory.createButton("up");
		bUp.setForeground(new Color(40, 40, 40));
		bDown = factory.createButton("down");
		bDown.setForeground(new Color(40, 40, 40));

		int x, y = 5, width, heigth = 20;
		x = 5;
		width = 50;
		merge.setBounds(x, y, width, heigth);
		x += width + 2;
		width = 150;
		tFrom1.setBounds(x, y, width, heigth);
		x += width + 2;
		width = 10;
		plus.setBounds(x, y, width, heigth);
		x += width + 2;
		width = 150;
		tFrom2.setBounds(x, y, width, heigth);
		x += width + 2;
		width = 10;
		returns.setBounds(x, y, width, heigth);
		x += width + 2;
		width = 150;
		tInto.setBounds(x, y, width, heigth);
		x += width + 2;
		width = 50;
		bRemove.setBounds(x, y, width, heigth);
		x += width + 2;
		width = 50;
		bUp.setBounds(x, y, width, heigth);
		x += width + 2;
		width = 50;
		bDown.setBounds(x, y, width, heigth);
		WIDTH = x + width + 4;
		HEIGHT = heigth + 4;

		setFirst(first);
		setLast(last);

		setLayout(null);
		add(merge);
		add(tFrom1);
		add(plus);
		add(tFrom2);
		add(returns);
		add(tInto);
		add(bUp);
		add(bDown);
		add(bRemove);
		refresh();

		TextFocusListener fl = new TextFocusListener();
		tFrom1.addFocusListener(fl);
		tFrom2.addFocusListener(fl);
		tInto.addFocusListener(fl);
	}

	public boolean isFirst() {
		return first;
	}

	public void setFirst(boolean b) {
		first = b;
		bUp.setVisible(!first);
	}

	public boolean isLast() {
		return last;
	}

	public void setLast(boolean b) {
		last = b;
		bDown.setVisible(!last);
	}

	public void refresh() {
		validate();
		repaint();
	}

	public String getFrom1() {
		return tFrom1.getText();
	}

	public String getFrom2() {
		return tFrom2.getText();
	}

	public String getInto() {
		return tInto.getText();
	}

	public JButton upButton() {
		return bUp;
	}

	public JButton downButton() {
		return bDown;
	}

	public JButton removeButton() {
		return bRemove;
	}

	private class TextFocusListener extends FocusAdapter {
		public void focusGained(FocusEvent e) {
			((JTextField) e.getSource()).selectAll();
		}
	}
}
