package org.processmining.plugins.simplelogoperations;

import java.util.ArrayList;
import java.util.HashMap;

public class RenameMergeEventSettings {
	private HashMap<String, ArrayList<RenameSetting>> renameSettings;
	private ArrayList<MergeSetting> mergeSettings;

	public RenameMergeEventSettings() {
		renameSettings = new HashMap<String, ArrayList<RenameSetting>>();
		mergeSettings = new ArrayList<MergeSetting>();
	}

	public void addRenameSetting(RenameSetting rs) {
		if (!renameSettings.containsKey(rs.getField()))
			renameSettings.put(rs.getField(), new ArrayList<RenameSetting>());
		renameSettings.get(rs.getField()).add(rs);
	}

	public void addMergeSetting(MergeSetting gs) {
		mergeSettings.add(gs);
	}

	public int numRenameSettings() {
		return renameSettings.size();
	}

	public int numRenameSettings(String field) {
		if (!renameSettings.containsKey(field))
			return 0;
		return renameSettings.get(field).size();
	}

	public int numMergeSettings() {
		return mergeSettings.size();
	}

	public RenameSetting getRenameSetting(String field, int i) {
		if (i < 0 || !renameSettings.containsKey(field) || i >= renameSettings.get(field).size())
			return null;
		return renameSettings.get(field).get(i);
	}

	public MergeSetting getMergeSetting(int i) {
		if (i < 0 || i >= mergeSettings.size())
			return null;
		return mergeSettings.get(i);
	}
}
