package org.processmining.plugins.simplelogoperations;

import java.awt.Color;
import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import com.fluxicon.slickerbox.factory.SlickerDecorator;
import com.fluxicon.slickerbox.factory.SlickerFactory;

public class RenamePanel extends JPanel {
	/**
	 * 
	 */
	private static final long serialVersionUID = -4238484431760056019L;
	public static int WIDTH = 0, HEIGHT = 0;
	private boolean first, last;
	private JComboBox cField;
	private JTextField tFrom, tInto;
	private JButton bRemove, bUp, bDown;

	public RenamePanel(boolean first, boolean last) {
		super();

		SlickerFactory factory = SlickerFactory.instance();
		SlickerDecorator decorator = SlickerDecorator.instance();

		setBackground(Color.gray);

		JLabel rename = factory.createLabel("Rename");
		rename.setForeground(new Color(40, 40, 40));

		String[] fields = { "Task", "Originator" };
		cField = factory.createComboBox(fields);
		cField.setForeground(new Color(40, 40, 40));
		decorator.decorate(cField);

		tFrom = new JTextField("from");
		tFrom.setForeground(new Color(40, 40, 40));
		tInto = new JTextField("into");
		tInto.setForeground(new Color(40, 40, 40));

		bRemove = factory.createButton("remove");
		bRemove.setForeground(new Color(40, 40, 40));
		bUp = factory.createButton("up");
		bUp.setForeground(new Color(40, 40, 40));
		bDown = factory.createButton("down");
		bDown.setForeground(new Color(40, 40, 40));

		int x, y = 5, width, heigth = 20;
		x = 5;
		width = 50;
		rename.setBounds(x, y, width, heigth);
		x += width + 2;
		width = 150;
		cField.setBounds(x, y, width, heigth);
		x += width + 2;
		width = 150;
		tFrom.setBounds(x, y, width, heigth);
		x += width + 2;
		width = 150;
		tInto.setBounds(x, y, width, heigth);
		x += width + 2;
		width = 50;
		bRemove.setBounds(x, y, width, heigth);
		x += width + 2;
		width = 50;
		bUp.setBounds(x, y, width, heigth);
		x += width + 2;
		width = 50;
		bDown.setBounds(x, y, width, heigth);
		WIDTH = x + width + 4;
		HEIGHT = heigth + 4;

		setFirst(first);
		setLast(last);

		setLayout(null);
		add(rename);
		add(cField);
		add(tFrom);
		add(tInto);
		add(bRemove);
		add(bUp);
		add(bDown);
		refresh();

		TextFocusListener fl = new TextFocusListener();
		tFrom.addFocusListener(fl);
		tInto.addFocusListener(fl);
	}

	public boolean isFirst() {
		return first;
	}

	public void setFirst(boolean b) {
		first = b;
		bUp.setVisible(!first);
	}

	public boolean isLast() {
		return last;
	}

	public void setLast(boolean b) {
		last = b;
		bDown.setVisible(!last);
	}

	public void refresh() {
		validate();
		repaint();
	}

	public String getField() {
		return cField.getSelectedItem().toString();
	}

	public String getFrom() {
		return tFrom.getText();
	}

	public String getInto() {
		return tInto.getText();
	}

	public JButton upButton() {
		return bUp;
	}

	public JButton downButton() {
		return bDown;
	}

	public JButton removeButton() {
		return bRemove;
	}

	private class TextFocusListener extends FocusAdapter {
		public void focusGained(FocusEvent e) {
			((JTextField) e.getSource()).selectAll();
		}
	}
}
